module IpWhitelist
  module Interceptor
    extend ActiveSupport::Concern

    included do
      private :ip_intercept

      rescue_from IpWhitelist::Error do |e|
        render json: { code: e.code, message: e.message }, status: e.status
      end
    end

    def ip_intercept
      unless IpWhitelist::List.ips.includes(request.ip)
        raise IpWhitelist::Error.new(status: 403, message: 'Invaild Request')
      end
    end
  end
end

