module IpWhitelist
  class List < ActiveRecord::Base
    REDIS_KEY = 'ip-whitelist-redis'

    validates_presence_of :ips

    class << self
      def ips
        IpWhitelist.redis.get(REDIS_KEY)&.split(',') || load
      end

      def load
        ips_ary = all.pluck(:ips).map { |ips_str| ips_str.split(',')}.reduce(:+)
        IpWhitelist.redis.set(REDIS_KEY, ips_ary.join(','))
        ips_ary
      end
    end
  end
end

